#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll  mn=2*1e5+100;
const ll  szt=4*mn;
int  main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll  n,c,q;
    cin>>n>>c>>q;
    string s;
    cin>>s;
    //subntask 1
    if(n<=4000 && q<=4000 && c==n)
    {
        while(q--)
        {
            ll  l,r;
            cin>>l>>r;
            l--; r--;
            for(ll  i=l;i<=r;i++)
            {
                if(s[i]=='0') s[i]='1';
                else s[i]='0';
            }
            ll  t=0;
            for(ll  i=0;i<n;i++) if(s[i]=='1') t++;
            cout<<t<<endl;
        }
    }
    //subtask2
    else if(c==n)
    {
        ll  tr=0;
        for(ll  i=0;i<n;i++)
        {
            if(s[i]=='1') tr++;
        }
        while(q--)
        {
            ll  l,r;
            cin>>l>>r;
            l--; r--;
            if(s[l]=='1')
            {
                tr--;
                s[l]='0';
            }
            else
            {
                tr++;
                s[l]='1';
            }
            cout<<tr<<endl;
        }
    }
    //subtask 4
    else if(c==1)
    {
        while(q--)
        {
            ll  l,r;
            cin>>l>>r;
            l--; r--;
            for(ll  i=l;i<=r;i++)
            {
                if(s[i]=='0') s[i]='1';
                else s[i]='0';
            }
            ll  kolko=0;
            bool usao=false;
            for(ll  i=0;i<n;i++)
            {
                if(s[i]=='1') usao=true;
                else
                {
                    if(usao) kolko++;
                    usao=false;
                }
            }
            if(usao) kolko++;
            cout<<kolko<<endl;
        }
    }
    else
    {
        while(q--)
        {
            cout<<0<<endl;
        }
    }
    return 0;
}